<template>
  <div class="address-input">
    <v-autocomplete
      v-bind="$attrs"
      label="Buscar rua"
      :search-input.sync="search"
      :items="results"
      item-text="street"
      auto-select-first="auto-select-first"
      return-object="return-object"
      no-filter="no-filter"
      hide-no-data="hide-no-data"
      v-model="result"
    >
      <template v-slot:item="data">
        <v-list-item-content>
          <v-list-item-title>{{data.item.street}}</v-list-item-title>
          <v-list-item-subtitle>{{data.item.neighborhood}}</v-list-item-subtitle>
        </v-list-item-content>
      </template>
    </v-autocomplete>
    <v-text-field
      v-bind="$attrs"
      label="Rua *"
      v-model="street"
      :rules="[vRequired('Rua')]"
    />
    <v-text-field
      v-bind="$attrs"
      label="CEP"
      v-mask="'#####-###'"
      v-model="cep"
     />    <v-text-field
      v-bind="$attrs"
      label="Número da Casa *"
      v-model="number"
      :rules="[vRequired('Número')]"
     />    <v-text-field
      v-bind="$attrs"
      label="Complemento"
      v-model="complement"
     />  </div>

</template>

<script lang="ts">
import Vue from 'vue'

import vRequired from '@/validators/required'

import StreetSearchQuery from '@/gql/StreetSearch.gql'
import { IAddress } from '../../types/Address'

export default Vue.extend({
  name: 'AddressInput',
  props: {
    value: { type: Object, default: null }
  },
  data: (): {
    street: string | null,
    cep: string | null,
    number: string | null,
    complement: string | null,

    search: string | null,
    result: IAddress | null,
    vRequired: any
  } => ({
    street: null,
    cep: null,
    number: null,
    complement: null,

    search: '',
    result: null,

    vRequired
  }),
  watch: {
    value () {
      if (this.value === null) {
        this.street = null
        this.cep = null
        this.number = null
        this.complement = null
        this.search = ''
        this.result = null
      }
    },
    street () {
      this.updated()
    },
    cep () {
      if (!this.cep) this.cep = null
      this.updated()
    },
    number () {
      this.updated()
    },
    complement () {
      this.updated()
    },
    result () {
      if (this.result) {
        this.cep = this.result.cep
        this.street = this.result.street
      }

      this.updated()
    }
  },
  apollo: {
    results: {
      query: StreetSearchQuery,
      variables (): { search: string } {
        return {
          search: this.search || ''
        }
      }
    }
  },
  methods: {
    updated () {
      this.$emit('input', {
        street: this.street,
        cep: this.cep,
        number: this.number,
        complement: this.complement
      })
    }
  }
})
</script>

<style lang="scss" scoped>
.document-type {
  width: 10em;
}
</style>
